# 1 "parixevent.c"





 


static char vcid[] = "$Id: chevent.c,v 1.14 1995/09/18 21:11:36 gropp Exp $";



# 1 "./mpid.h"





 





# 1 "../../include/mpiimpl.h"





 

 




 

# 1 "../../include/mpi.h"





 

 




 

# 17 "../../include/mpi.h"


  
 





 
 
typedef struct MPIR_DATATYPE *MPI_Datatype;









 
extern struct MPIR_DATATYPE MPIR_I_CHAR, MPIR_I_SHORT, MPIR_I_INT, MPIR_I_LONG,
                            MPIR_I_UCHAR, MPIR_I_USHORT, MPIR_I_UINT, 
                            MPIR_I_ULONG, MPIR_I_FLOAT, MPIR_I_DOUBLE, 
                            MPIR_I_LONG_DOUBLE, MPIR_I_LONG_DOUBLE_INT,
                            MPIR_I_BYTE, MPIR_I_PACKED, MPIR_I_UB, MPIR_I_LB,
                            MPIR_I_LONG_LONG_INT, MPIR_I_2INTEGER, 
                            MPIR_I_FLOAT_INT, MPIR_I_DOUBLE_INT, 
                            MPIR_I_LONG_INT, MPIR_I_SHORT_INT, MPIR_I_2INT,
                            MPIR_I_REAL, MPIR_I_DOUBLE_PRECISION, 
                            MPIR_I_COMPLEX, MPIR_I_DCOMPLEX, 
                            MPIR_I_LONG_DOUBLE, MPIR_I_LONG_LONG_INT, 
                            MPIR_I_LOGICAL;























extern MPI_Datatype MPI_LONG_DOUBLE, MPI_LONG_DOUBLE_INT, 
       MPI_LONG_LONG_INT, MPI_2INTEGER;

 
extern MPI_Datatype MPIR_2real_dte, MPIR_2double_dte, 
                    MPIR_2complex_dte, MPIR_2dcomplex_dte, 
                    MPIR_int1_dte, 
                    MPIR_int2_dte, MPIR_int4_dte, MPIR_real4_dte, 
                    MPIR_real8_dte, MPI_REAL, MPI_DOUBLE_PRECISION;







 
 
typedef struct MPIR_COMMUNICATOR *MPI_Comm;
extern MPI_Comm MPI_COMM_WORLD, MPI_COMM_SELF;

 
typedef struct MPIR_GROUP *MPI_Group;
extern MPI_Group MPI_GROUP_EMPTY;

 
typedef struct MPIR_OP *MPI_Op;
extern MPI_Op MPI_MAX, MPI_MIN, MPI_SUM, MPI_PROD, MPI_LAND, MPI_BAND, 
              MPI_LOR, MPI_BOR, MPI_LXOR, MPI_BXOR, MPI_MINLOC, MPI_MAXLOC;

 
 
extern int MPI_TAG_UB, MPI_HOST, MPI_IO, MPI_WTIME_IS_GLOBAL;
 
extern int MPIR_TAG_UB, MPIR_HOST, MPIR_IO, MPIR_WTIME_IS_GLOBAL;

 







 



 




 


 










 
typedef struct { 
    int count;
    int MPI_SOURCE;
    int MPI_TAG;
    int MPI_ERROR;
} MPI_Status;


 
typedef long MPI_Aint;



typedef void (MPI_Handler_function)( MPI_Comm *, int *, ... );

# 159 "../../include/mpi.h"

typedef struct MPIR_Errhandler *MPI_Errhandler;
extern MPI_Errhandler MPI_ERRORS_ARE_FATAL, MPI_ERRORS_RETURN, 
       MPIR_ERRORS_WARN;


 




 
typedef union MPIR_HANDLE *MPI_Request;

 

typedef void (MPI_User_function)( void *invec, void *inoutvec, int *len,  
				   MPI_Datatype *datatype); 

# 180 "../../include/mpi.h"

 

typedef int (MPI_Copy_function)( MPI_Comm *oldcomm, int *keyval, 
				 void *extra_state,
			         void *attr_in, void *attr_out, int *flag);
typedef int (MPI_Delete_function)( MPI_Comm *comm, int *keyval, void *attr_val,
			           void *extra_state );

# 192 "../../include/mpi.h"

 

# 1 "../../include/mpi_errno.h"





 


 




 




# 20 "../../include/mpi_errno.h"

# 22 "../../include/mpi_errno.h"

# 24 "../../include/mpi_errno.h"



































# 195 "../../include/mpi.h"

 

# 1 "../../include/binding.h"




# 1 "../../include/mpi.h"





 

 


# 204 "../../include/mpi.h"




# 5 "../../include/binding.h"


int MPI_Send(void* buf, int count, MPI_Datatype datatype, int dest, int tag, 
	     MPI_Comm comm);
int MPI_Recv(void* buf, int count, MPI_Datatype datatype, int source, 
	     int tag, MPI_Comm comm, MPI_Status *status);
int MPI_Get_count(MPI_Status *status, MPI_Datatype datatype, int *count);
int MPI_Bsend(void* buf, int count, MPI_Datatype datatype, int dest, int tag, 
	      MPI_Comm comm);
int MPI_Ssend(void* buf, int count, MPI_Datatype datatype, int dest, int tag, 
	      MPI_Comm comm);
int MPI_Rsend(void* buf, int count, MPI_Datatype datatype, int dest, int tag, 
	      MPI_Comm comm);
int MPI_Buffer_attach( void* buffer, int size);
int MPI_Buffer_detach( void* buffer, int* size);
int MPI_Isend(void* buf, int count, MPI_Datatype datatype, int dest, int tag, 
	      MPI_Comm comm, MPI_Request *request);
int MPI_Ibsend(void* buf, int count, MPI_Datatype datatype, int dest, 
	       int tag, MPI_Comm comm, MPI_Request *request);
int MPI_Issend(void* buf, int count, MPI_Datatype datatype, int dest, 
	       int tag, MPI_Comm comm, MPI_Request *request);
int MPI_Irsend(void* buf, int count, MPI_Datatype datatype, int dest, 
	       int tag, MPI_Comm comm, MPI_Request *request);
int MPI_Irecv(void* buf, int count, MPI_Datatype datatype, int source, 
	      int tag, MPI_Comm comm, MPI_Request *request);
int MPI_Wait(MPI_Request *request, MPI_Status *status);
int MPI_Test(MPI_Request *request, int *flag, MPI_Status *status);
int MPI_Request_free(MPI_Request *request);
int MPI_Waitany(int, MPI_Request *, int *, MPI_Status *);
int MPI_Testany(int, MPI_Request *, int *, int *, MPI_Status *);
int MPI_Waitall(int count, MPI_Request *array_of_requests, 
		MPI_Status *array_of_statuses);
int MPI_Testall(int count, MPI_Request *array_of_requests, int *flag, 
		MPI_Status *array_of_statuses);
int MPI_Waitsome(int incount, MPI_Request *array_of_requests, int *outcount, 
		 int *array_of_indices, MPI_Status *array_of_statuses);
int MPI_Testsome(int incount, MPI_Request *array_of_requests, int *outcount, 
		 int *array_of_indices, MPI_Status *array_of_statuses);
int MPI_Iprobe(int source, int tag, MPI_Comm comm, int *flag, 
	       MPI_Status *status);
int MPI_Probe(int source, int tag, MPI_Comm comm, MPI_Status *status);
int MPI_Cancel(MPI_Request *request);
int MPI_Test_cancelled(MPI_Status *status, int *flag);
int MPI_Send_init(void* buf, int count, MPI_Datatype datatype, int dest, 
		  int tag, MPI_Comm comm, MPI_Request *request);
int MPI_Bsend_init(void* buf, int count, MPI_Datatype datatype, int dest, 
		   int tag, MPI_Comm comm, MPI_Request *request);
int MPI_Ssend_init(void* buf, int count, MPI_Datatype datatype, int dest, 
		   int tag, MPI_Comm comm, MPI_Request *request);
int MPI_Rsend_init(void* buf, int count, MPI_Datatype datatype, int dest, 
		   int tag, MPI_Comm comm, MPI_Request *request);
int MPI_Recv_init(void* buf, int count, MPI_Datatype datatype, int source, 
		  int tag, MPI_Comm comm, MPI_Request *request);
int MPI_Start(MPI_Request *request);
int MPI_Startall(int count, MPI_Request *array_of_requests);
int MPI_Sendrecv(void *sendbuf, int sendcount, MPI_Datatype sendtype, 
		 int dest, int sendtag, void *recvbuf, int recvcount, 
		 MPI_Datatype recvtype, int source, int recvtag, 
		 MPI_Comm comm, MPI_Status *status);
int MPI_Sendrecv_replace(void* buf, int count, MPI_Datatype datatype, 
			 int dest, int sendtag, int source, int recvtag, 
			 MPI_Comm comm, MPI_Status *status);
int MPI_Type_contiguous(int count, MPI_Datatype oldtype, 
			MPI_Datatype *newtype);
int MPI_Type_vector(int count, int blocklength, int stride, 
		    MPI_Datatype oldtype, MPI_Datatype *newtype);
int MPI_Type_hvector(int count, int blocklength, MPI_Aint stride, 
		     MPI_Datatype oldtype, MPI_Datatype *newtype);
int MPI_Type_indexed(int count, int *array_of_blocklengths, 
		     int *array_of_displacements, MPI_Datatype oldtype, 
		     MPI_Datatype *newtype);
int MPI_Type_hindexed(int count, int *array_of_blocklengths, 
		      MPI_Aint *array_of_displacements, MPI_Datatype oldtype, 
		      MPI_Datatype *newtype);
int MPI_Type_struct(int count, int *array_of_blocklengths, 
		    MPI_Aint *array_of_displacements, 
		    MPI_Datatype *array_of_types, MPI_Datatype *newtype);
int MPI_Address(void* location, MPI_Aint *address);
int MPI_Type_extent(MPI_Datatype datatype, MPI_Aint *extent);

 
int MPI_Type_size(MPI_Datatype datatype, MPI_Aint *size);
 
int MPI_Type_lb(MPI_Datatype datatype, MPI_Aint* displacement);
int MPI_Type_ub(MPI_Datatype datatype, MPI_Aint* displacement);
int MPI_Type_commit(MPI_Datatype *datatype);
int MPI_Type_free(MPI_Datatype *datatype);
int MPI_Get_elements(MPI_Status *status, MPI_Datatype datatype, int *count);
int MPI_Pack(void* inbuf, int incount, MPI_Datatype datatype, void *outbuf, 
	     int outsize, int *position,  MPI_Comm comm);
int MPI_Unpack(void* inbuf, int insize, int *position, void *outbuf, 
	       int outcount, MPI_Datatype datatype, MPI_Comm comm);
int MPI_Pack_size(int incount, MPI_Datatype datatype, MPI_Comm comm, 
		  int *size);
int MPI_Barrier(MPI_Comm comm );
int MPI_Bcast(void* buffer, int count, MPI_Datatype datatype, int root, 
	      MPI_Comm comm );
int MPI_Gather(void* sendbuf, int sendcount, MPI_Datatype sendtype, 
	       void* recvbuf, int recvcount, MPI_Datatype recvtype, 
	       int root, MPI_Comm comm); 
int MPI_Gatherv(void* sendbuf, int sendcount, MPI_Datatype sendtype, 
		void* recvbuf, int *recvcounts, int *displs, 
		MPI_Datatype recvtype, int root, MPI_Comm comm); 
int MPI_Scatter(void* sendbuf, int sendcount, MPI_Datatype sendtype, 
		void* recvbuf, int recvcount, MPI_Datatype recvtype, 
		int root, MPI_Comm comm);
int MPI_Scatterv(void* sendbuf, int *sendcounts, int *displs, 
		 MPI_Datatype sendtype, void* recvbuf, int recvcount, 
		 MPI_Datatype recvtype, int root, MPI_Comm comm);
int MPI_Allgather(void* sendbuf, int sendcount, MPI_Datatype sendtype, 
		  void* recvbuf, int recvcount, MPI_Datatype recvtype, 
		  MPI_Comm comm);
int MPI_Allgatherv(void* sendbuf, int sendcount, MPI_Datatype sendtype, 
		   void* recvbuf, int *recvcounts, int *displs, 
		   MPI_Datatype recvtype, MPI_Comm comm);
int MPI_Alltoall(void* sendbuf, int sendcount, MPI_Datatype sendtype, 
		 void* recvbuf, int recvcount, MPI_Datatype recvtype, 
		 MPI_Comm comm);
int MPI_Alltoallv(void* sendbuf, int *sendcounts, int *sdispls, 
		  MPI_Datatype sendtype, void* recvbuf, int *recvcounts, 
		  int *rdispls, MPI_Datatype recvtype, MPI_Comm comm);
int MPI_Reduce(void* sendbuf, void* recvbuf, int count, 
	       MPI_Datatype datatype, MPI_Op op, int root, MPI_Comm comm);
int MPI_Op_create(MPI_User_function *function, int commute, MPI_Op *op);
int MPI_Op_free( MPI_Op *op);
int MPI_Allreduce(void* sendbuf, void* recvbuf, int count, 
		  MPI_Datatype datatype, MPI_Op op, MPI_Comm comm);
int MPI_Reduce_scatter(void* sendbuf, void* recvbuf, int *recvcounts, 
		       MPI_Datatype datatype, MPI_Op op, MPI_Comm comm);
int MPI_Scan(void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype, 
	     MPI_Op op, MPI_Comm comm );
int MPI_Group_size(MPI_Group group, int *size);
int MPI_Group_rank(MPI_Group group, int *rank);
int MPI_Group_translate_ranks (MPI_Group group1, int n, int *ranks1, 
			       MPI_Group group2, int *ranks2);
int MPI_Group_compare(MPI_Group group1, MPI_Group group2, int *result);
int MPI_Comm_group(MPI_Comm comm, MPI_Group *group);
int MPI_Group_union(MPI_Group group1, MPI_Group group2, MPI_Group *newgroup);
int MPI_Group_intersection(MPI_Group group1, MPI_Group group2, 
			   MPI_Group *newgroup);
int MPI_Group_difference(MPI_Group group1, MPI_Group group2, 
			 MPI_Group *newgroup);
int MPI_Group_incl(MPI_Group group, int n, int *ranks, MPI_Group *newgroup);
int MPI_Group_excl(MPI_Group group, int n, int *ranks, MPI_Group *newgroup);
int MPI_Group_range_incl(MPI_Group group, int n, int ranges[][3], 
			 MPI_Group *newgroup);
int MPI_Group_range_excl(MPI_Group group, int n, int ranges[][3], 
			 MPI_Group *newgroup);
int MPI_Group_free(MPI_Group *group);
int MPI_Comm_size(MPI_Comm comm, int *size);
int MPI_Comm_rank(MPI_Comm comm, int *rank);
int MPI_Comm_compare(MPI_Comm comm1, MPI_Comm comm2, int *result);
int MPI_Comm_dup(MPI_Comm comm, MPI_Comm *newcomm);
int MPI_Comm_create(MPI_Comm comm, MPI_Group group, MPI_Comm *newcomm);
int MPI_Comm_split(MPI_Comm comm, int color, int key, MPI_Comm *newcomm);
int MPI_Comm_free(MPI_Comm *comm);
int MPI_Comm_test_inter(MPI_Comm comm, int *flag);
int MPI_Comm_remote_size(MPI_Comm comm, int *size);
int MPI_Comm_remote_group(MPI_Comm comm, MPI_Group *group);
int MPI_Intercomm_create(MPI_Comm local_comm, int local_leader, 
			 MPI_Comm peer_comm, int remote_leader, 
			 int tag, MPI_Comm *newintercomm);
int MPI_Intercomm_merge(MPI_Comm intercomm, int high, MPI_Comm *newintracomm);
int MPI_Keyval_create(MPI_Copy_function *copy_fn, 
		      MPI_Delete_function *delete_fn, 
		      int *keyval, void* extra_state);
int MPI_Keyval_free(int *keyval);
int MPI_Attr_put(MPI_Comm comm, int keyval, void* attribute_val);
int MPI_Attr_get(MPI_Comm comm, int keyval, void *attribute_val, int *flag);
int MPI_Attr_delete(MPI_Comm comm, int keyval);
int MPI_Topo_test(MPI_Comm comm, int *status);
int MPI_Cart_create(MPI_Comm comm_old, int ndims, int *dims, int *periods,
		    int reorder, MPI_Comm *comm_cart);
int MPI_Dims_create(int nnodes, int ndims, int *dims);
int MPI_Graph_create(MPI_Comm, int, int *, int *, int, MPI_Comm *);
int MPI_Graphdims_get(MPI_Comm comm, int *nnodes, int *nedges);
int MPI_Graph_get(MPI_Comm, int, int, int *, int *);
int MPI_Cartdim_get(MPI_Comm comm, int *ndims);
int MPI_Cart_get(MPI_Comm comm, int maxdims, int *dims, int *periods,
		 int *coords);
int MPI_Cart_rank(MPI_Comm comm, int *coords, int *rank);
int MPI_Cart_coords(MPI_Comm comm, int rank, int maxdims, int *coords);
int MPI_Graph_neighbors_count(MPI_Comm comm, int rank, int *nneighbors);
int MPI_Graph_neighbors(MPI_Comm comm, int rank, int maxneighbors,
			int *neighbors);
int MPI_Cart_shift(MPI_Comm comm, int direction, int disp, 
		   int *rank_source, int *rank_dest);
int MPI_Cart_sub(MPI_Comm comm, int *remain_dims, MPI_Comm *newcomm);
int MPI_Cart_map(MPI_Comm comm, int ndims, int *dims, int *periods, 
		 int *newrank);
int MPI_Graph_map(MPI_Comm, int, int *, int *, int *);
int MPI_Get_processor_name(char *name, int *result_len);
int MPI_Errhandler_create(MPI_Handler_function *function, 
			  MPI_Errhandler *errhandler);
int MPI_Errhandler_set(MPI_Comm comm, MPI_Errhandler errhandler);
int MPI_Errhandler_get(MPI_Comm comm, MPI_Errhandler *errhandler);
int MPI_Errhandler_free(MPI_Errhandler *errhandler);
int MPI_Error_string(int errorcode, char *string, int *result_len);
int MPI_Error_class(int errorcode, int *errorclass);
double MPI_Wtime(void);
double MPI_Wtick(void);

double PMPI_Wtime(void);
double PMPI_Wtick(void);

int MPI_Init(int *argc, char ***argv);
int MPI_Finalize(void);
int MPI_Initialized(int *flag);
int MPI_Abort(MPI_Comm comm, int errorcode);
int MPI_Pcontrol(const int level, ...);

int  MPIR_null_copy_fn  ( MPI_Comm *oldcomm, int *keyval, void *extra_state, 
		       void *attr_in, void *attr_out, int *flag );
int  MPIR_null_delete_fn  ( MPI_Comm *comm, int *keyval, void *attr, 
			 void *extra_state );
int  MPIR_dup_fn  ( MPI_Comm *comm, int *keyval, void *extra_state, void *attr_in,
		 void *attr_out, int *flag );

# 232 "../../include/binding.h"


# 198 "../../include/mpi.h"


# 202 "../../include/mpi.h"






# 15 "../../include/mpiimpl.h"


  

# 1 "../../include/patchlevel.h"



# 19 "../../include/mpiimpl.h"

# 1 "../../include/dmpiatom.h"





 

 




 

# 1 "../../include/mpi.h"





 

 


# 204 "../../include/mpi.h"




# 15 "../../include/dmpiatom.h"



 







 






# 36 "../../include/dmpiatom.h"
 

 
typedef unsigned long MPIR_uint32;

typedef struct _MPIR_HBT_node {
   unsigned long cookie;                      
  void *value;
  int   keyval;
  short balance;
  struct _MPIR_HBT_node *left;
  struct _MPIR_HBT_node *right;
} MPIR_HBT_node;


typedef struct _MPIR_HBT {
   unsigned long cookie;                      
  unsigned int   height;
  int            ref_count;
  MPIR_HBT_node *root;
} MPIR_HBT;


typedef struct  {
   unsigned long cookie;                      
  int  (*copy_fn)();
  int  (*delete_fn)();
  void  *extra_state;
  int    FortranCalling;        





 
  int    ref_count;
  int    permanent;             
 
} MPIR_Attr_key;


extern int MPIR_TOPOLOGY_KEYVAL;   


typedef struct {
  int type;
   unsigned long cookie; 
  int nnodes;
  int nedges;
  int *index;
  int *edges;
} MPIR_GRAPH_TOPOLOGY;


typedef struct {
  int type;
   unsigned long cookie; 
  int nnodes;
  int ndims;
  int *dims;
  int *periods;
  int *position;
} MPIR_CART_TOPOLOGY;

typedef union {
  int type;
  MPIR_GRAPH_TOPOLOGY  graph;
  MPIR_CART_TOPOLOGY   cart;
} MPIR_TOPOLOGY;


struct MPIR_GROUP {
     unsigned long cookie;               
    int np;			         
    int local_rank;          
    int ref_count;           
    int N2_next;             
    int N2_prev;             
    int permanent;           
    int *lrank_to_grank;     
    int *set_mark;           
};





 
struct MPIR_Errhandler {
     unsigned long cookie;                      
    MPI_Handler_function *routine;
    int                  ref_count;
    };



typedef unsigned long MPIR_CONTEXT;








typedef enum { MPIR_INTRA=1, MPIR_INTER } MPIR_COMM_TYPE;


# 146 "../../include/dmpiatom.h"




# 152 "../../include/dmpiatom.h"





 
typedef struct MPIR_COLLOPS {
    int (*Barrier)  (MPI_Comm comm ) ;
    int (*Bcast)  (void* buffer, int count, MPI_Datatype datatype, int root,  MPI_Comm comm ) ;
# 162 "../../include/dmpiatom.h"
    int (*Gather)  (void* sendbuf, int sendcount, MPI_Datatype sendtype,  void* recvbuf, int recvcount, MPI_Datatype recvtype,  int root, MPI_Comm comm) ; 
# 165 "../../include/dmpiatom.h"
    int (*Gatherv)  (void* sendbuf, int sendcount, MPI_Datatype sendtype,  void* recvbuf, int *recvcounts, int *displs,  MPI_Datatype recvtype, int root, MPI_Comm comm) ; 
# 168 "../../include/dmpiatom.h"
    int (*Scatter)  (void* sendbuf, int sendcount, MPI_Datatype sendtype,  void* recvbuf, int recvcount, MPI_Datatype recvtype,  int root, MPI_Comm comm) ;
# 171 "../../include/dmpiatom.h"
    int (*Scatterv)  (void* sendbuf, int *sendcounts, int *displs,  MPI_Datatype sendtype, void* recvbuf, int recvcount,  MPI_Datatype recvtype, int root, MPI_Comm comm) ;
# 174 "../../include/dmpiatom.h"
    int (*Allgather)  (void* sendbuf, int sendcount, MPI_Datatype sendtype,  void* recvbuf, int recvcount, MPI_Datatype recvtype,  MPI_Comm comm) ;
# 177 "../../include/dmpiatom.h"
    int (*Allgatherv)  (void* sendbuf, int sendcount, MPI_Datatype sendtype,  void* recvbuf, int *recvcounts, int *displs,  MPI_Datatype recvtype, MPI_Comm comm) ;
# 180 "../../include/dmpiatom.h"
    int (*Alltoall)  (void* sendbuf, int sendcount, MPI_Datatype sendtype,  void* recvbuf, int recvcount, MPI_Datatype recvtype,  MPI_Comm comm) ;
# 183 "../../include/dmpiatom.h"
    int (*Alltoallv)  (void* sendbuf, int *sendcounts, int *sdispls,  MPI_Datatype sendtype, void* recvbuf, int *recvcounts,  int *rdispls, MPI_Datatype recvtype, MPI_Comm comm) ;
# 186 "../../include/dmpiatom.h"
    int (*Reduce)  (void* sendbuf, void* recvbuf, int count,  MPI_Datatype datatype, MPI_Op op, int root, MPI_Comm comm) ;
# 188 "../../include/dmpiatom.h"
    int (*Allreduce)  (void* sendbuf, void* recvbuf, int count,  MPI_Datatype datatype, MPI_Op op, MPI_Comm comm) ;
# 190 "../../include/dmpiatom.h"
    int (*Reduce_scatter)  (void* sendbuf, void* recvbuf, int *recvcounts,  MPI_Datatype datatype, MPI_Op op, MPI_Comm comm) ;
# 192 "../../include/dmpiatom.h"
    int (*Scan)  (void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype,  MPI_Op op, MPI_Comm comm ) ;
# 194 "../../include/dmpiatom.h"
    int ref_count;      
} MPIR_COLLOPS;














 

struct MPIR_COMMUNICATOR {
     unsigned long cookie;                     
    int           np;              
    int           local_rank;      
    int           *lrank_to_grank; 
    MPIR_CONTEXT   send_context;   
    MPIR_CONTEXT   recv_context;   
    void          *ADIctx;         

    MPIR_COMM_TYPE comm_type;	   
    MPI_Group     group;	   
    MPI_Group     local_group;     
    MPI_Comm      comm_coll;       

    int            ref_count;      
    void          *comm_cache;	   
    MPIR_HBT      *attr_cache;     
    struct MPIR_Errhandler *error_handler;   
    int            permanent;       
    void          *mutex;           

    int           is_homogeneous; 

 

    


 

    


 
    void          *ADIBarrier;
    void          *ADIReduce;
    void          *ADIScan;
    void          *ADIBcast;
    void          *ADICollect;

    void          *adiCollCtx;
    MPIR_COLLOPS  *collops;
};

typedef enum {
  MPIR_NO = 0, MPIR_YES
} MPIR_BOOL;








 
typedef enum {
    MPIR_INT, MPIR_FLOAT, MPIR_DOUBLE, MPIR_COMPLEX, MPIR_LONG, MPIR_SHORT,
    MPIR_CHAR, MPIR_BYTE, MPIR_UCHAR, MPIR_USHORT, MPIR_ULONG, MPIR_UINT,
    MPIR_CONTIG, MPIR_VECTOR, MPIR_HVECTOR, MPIR_INDEXED,
    MPIR_HINDEXED, MPIR_STRUCT, MPIR_DOUBLE_COMPLEX, MPIR_PACKED, 
	MPIR_UB, MPIR_LB, MPIR_LONGDOUBLE, MPIR_LONGLONGINT, 
    MPIR_LOGICAL, MPIR_FORT_INT 
} MPIR_NODETYPE;

 








 

# 20 "../../include/mpiimpl.h"

# 1 "../../include/mpi_bc.h"





 

 




 
             





 

# 23 "../../include/mpi_bc.h"


 


              


            


            


            


 
typedef enum { 
    MPIR_MODE_STANDARD = 0, 
    MPIR_MODE_READY = 0x1, 
    MPIR_MODE_SYNCHRONOUS = 0x2, 
    MPIR_MODE_BUFFERED = 0x3,
    MPIR_MODE_SYNC_ACK = 0x4,
    MPIR_MODE_RECV = 0x5          
} MPIR_Mode;

 


 
extern int MPIR_Has_been_initialized;



# 21 "../../include/mpiimpl.h"

# 1 "../../include/dmpi.h"





 

 

 





# 17 "../../include/dmpi.h"

# 19 "../../include/dmpi.h"

# 21 "../../include/dmpi.h"

# 23 "../../include/dmpi.h"



# 31 "../../include/dmpi.h"
 
 




# 22 "../../include/mpiimpl.h"

# 1 "../../include/mpir.h"





 

 






# 1 "/usr/transputer/parix1.2/include/stdio.h"




 





# 1 "/usr/transputer/parix1.2/include/null.h"


 






# 12 "/usr/transputer/parix1.2/include/null.h"


# 11 "/usr/transputer/parix1.2/include/stdio.h"


# 1 "/usr/transputer/parix1.2/include/sys/size_t.h"


 




typedef unsigned int	size_t;	 


# 13 "/usr/transputer/parix1.2/include/stdio.h"

typedef long	fpos_t;







 


typedef struct {
	int	_cnt;
	unsigned char	*_ptr;
	unsigned char	*_base;
	unsigned char	_flag;
	char	_file;
} FILE;





 











# 1 "/usr/transputer/parix1.2/include/seek.h"




 










# 49 "/usr/transputer/parix1.2/include/stdio.h"













 
int	remove(const char *_filename);
int	rename(const char *_old, const char *_new);
FILE	*tmpfile(void);
char	*tmpnam(char *_s);
int	fclose(FILE *_stream);
int	fflush(FILE *_stream);
FILE	*fopen(const char *_filename, const char *_mode);
FILE	*freopen(const char *_filename, const char *_mode, FILE *_stream);
void	setbuf(FILE *_stream, char *_buf);
int	setvbuf(FILE *_stream, char *_buf, int _mode, size_t _size);
int	fprintf(FILE *_stream, const char *_format, ...);
int	fscanf(FILE *_stream, const char *_format, ...);
int	printf(const char *_format, ...);
int	scanf(const char *_format, ...);
int	sprintf(char *_s, const char *_format, ...);
int	sscanf(char *_s, const char *_format, ...);
int	vfprintf(FILE *_stream, const char *_format, char *_arg);
int	vprintf(const char *_format, char *_arg);
int	vsprintf(char *_s, const char *_format, char *_arg);
int	fgetc(FILE *_stream);
char	*fgets(char *_s, int _n, FILE *_stream);
int	fputc(int _c, FILE *_stream);
int	fputs(const char *_s, FILE *_stream);
int	getc(FILE *_stream);
int	getchar(void);
char	*gets(char *_s);
int	putc(int _c, FILE *_stream);
int	putchar(int _c);
int	puts(const char *_s);
int	ungetc(int _c, FILE *_stream);
size_t	fread(void *_ptr, size_t _size, size_t _nmemb, FILE *_stream);
size_t	fwrite(const void *_ptr, size_t _size, size_t _nmemb, FILE *_stream);
int	fgetpos(FILE *_stream, fpos_t *_pos);
int	fseek(FILE *_stream, long _offset, int _whence);
int	fsetpos(FILE *_stream, fpos_t *_pos);
long	ftell(FILE *_stream);
void	rewind(FILE *_stream);
void	clearerr(FILE *_stream);
int	feof(FILE *_stream);
int	ferror(FILE *_stream);
void	perror(const char *_s);

int	_filbuf(FILE *_stream);
int	_flsbuf(int _c, FILE *_stream);





# 114 "/usr/transputer/parix1.2/include/stdio.h"








extern FILE	_iob[ 20 ];
extern unsigned char *_bufendtab[];


# 137 "/usr/transputer/parix1.2/include/stdio.h"









# 15 "../../include/mpir.h"

# 1 "../../include/mpi.h"





 

 


# 204 "../../include/mpi.h"




# 16 "../../include/mpir.h"

# 1 "../../include/mpi_bc.h"





 

 


# 57 "../../include/mpi_bc.h"

# 17 "../../include/mpir.h"

# 1 "../../include/dmpi.h"





 

 

 


# 35 "../../include/dmpi.h"


# 18 "../../include/mpir.h"

# 1 ".//dm.h"





 






 









# 35 ".//dm.h"






 






 



# 1 "/usr/transputer/parix1.2/include/stdio.h"




 


# 52 ".//dm.h"
 
 

# 74 ".//dm.h"




 




 



# 89 ".//dm.h"





 

# 101 ".//dm.h"

# 104 ".//dm.h"


# 108 ".//dm.h"
typedef long MPID_Aint;







 
typedef int MPID_RNDV_T;


 
typedef enum { MPID_NOTBLOCKING = 0, MPID_BLOCKING } MPID_BLOCKING_TYPE;












































 
typedef struct {
    int           is_non_blocking;
         
    void          *start;
    int           bytes_as_contig;
         
    int sid;              


 
    MPID_RNDV_T   recv_handle;      
 

# 185 ".//dm.h"
    } MPID_SHANDLE;

typedef struct {
    int           is_non_blocking;
         
    void          *start;
    int           bytes_as_contig;
         
    int rid;              

 
    MPID_Aint     send_id;          




 
    MPID_RNDV_T   recv_handle;      
 
    char          *temp;             
    int           mode;             
 
    int           from;             

 
    } MPID_RHANDLE;







 














 

# 236 ".//dm.h"

# 238 ".//dm.h"

# 240 ".//dm.h"

# 242 ".//dm.h"


 

# 249 ".//dm.h"

# 252 ".//dm.h"



# 256 ".//dm.h"

# 259 ".//dm.h"


# 262 ".//dm.h"

# 264 ".//dm.h"

# 266 ".//dm.h"

 

# 271 ".//dm.h"


 




 

# 283 ".//dm.h"

 


# 288 ".//dm.h"

# 290 ".//dm.h"

# 292 ".//dm.h"


# 295 ".//dm.h"

# 297 ".//dm.h"


# 300 ".//dm.h"

















 















 







 









 

# 365 ".//dm.h"




 






 



 




extern FILE *MPID_DEBUG_FILE;






 

# 400 ".//dm.h"




 

# 409 ".//dm.h"








 

# 420 ".//dm.h"

# 424 ".//dm.h"




 








 

 



extern void (*MPID_ErrorHandler)();
extern void MPID_DefaultErrorHandler();














 


typedef enum { MPID_H_NONE = 0, 
		   MPID_H_LSB, MPID_H_MSB, MPID_H_XDR } MPID_H_TYPE;



 
typedef struct {
    MPID_H_TYPE byte_order;
    int         short_size, 
                int_size,
                long_size,
                float_size,
                double_size,
                float_type;
    } MPID_INFO;
extern MPID_INFO *MPID_procinfo;
extern MPID_H_TYPE MPID_byte_order;


# 484 ".//dm.h"


# 1 "../../include/mpiimpl.h"





 

 


# 212 "../../include/mpiimpl.h"



# 486 ".//dm.h"



# 19 "../../include/mpir.h"
 



 



struct MPIR_DATATYPE {
    MPIR_NODETYPE dte_type;  
     unsigned long cookie;               
    MPIR_BOOL    committed;  
    int          is_contig;  
    int              basic;  
    int          permanent;  
    MPI_Aint        ub, lb;  
    MPI_Aint real_ub, real_lb;  
    int             has_ub;  
    int             has_lb;  
    int             extent;  
    int               size;  
    int           elements;  
    int          ref_count;  
    int              align;  
    int              count;  
    MPI_Aint        stride;  
    MPI_Aint      *indices;  
    int           blocklen;  
    int         *blocklens;  
    MPI_Datatype old_type;   
    MPI_Datatype *old_types; 
};

typedef enum {
    MPIR_SEND,
    MPIR_RECV
} MPIR_OPTYPE;



 

typedef struct {
    MPIR_OPTYPE handle_type;
     unsigned long cookie;                   
    int         contextid;
    int         partner;         
    int         tag;
    int         completer;      
 
    int         errval;          

    MPI_Datatype datatype;
    MPI_Comm    comm;           


 
    int         persistent;     
 
    int         active;         
 
    int         msgrep;         
 

    void *bufadd;        
    int buflen;          
    int count;           

    char *bufpos;        
    int  transfer_count;     
    int  totallen;       

    } MPIR_COMMON;

typedef struct {
    MPIR_OPTYPE handle_type;     
     unsigned long cookie;               
    int         contextid;   
    int         dest;        
    int         tag;         
    int         completer;      
 
    int         errval;          

    MPI_Datatype datatype;   
    MPI_Comm    comm;
    int         persistent;
    int         active;
    int         msgrep;         
 
    void *bufadd;        
    int buflen;          
    int count;           
    char *bufpos;        
                        


 
    int  transfer_count;     
    int  totallen;       

    MPIR_Mode mode;      
    int  lrank;                  
    void *bsend;         

    MPID_SHANDLE dev_shandle;    
} MPIR_SHANDLE;

typedef struct {
    MPIR_OPTYPE handle_type;     
     unsigned long cookie;               
    int         contextid;   
    int         source;      
    int         tag;         
    int         completer;      
 
    int         errval;          

    MPI_Datatype datatype;   
    MPI_Comm    comm;
    int         persistent;
    int         active;
    int         msgrep;         
 
    void *bufadd;        
    int buflen;          
    int count;           
    char *bufpos;        
    int  transfer_count;     
    int  totallen;           

    void *p;             
    int  len;            
    int  actcount;       

    MPID_RHANDLE dev_rhandle;    

    
 
    int perm_source, perm_tag, perm_len;

} MPIR_RHANDLE;







 
typedef struct {
    MPIR_OPTYPE handle_type;     
     unsigned long cookie;               
    int         completer;      
 
    int         active;
    int         (*create_ureq)();
    int         (*free_ureq)();
    int         (*wait_ureq)();
    int         (*test_ureq)();
    int         (*start_ureq)();
    int         (*cancel_ureq)();
    void        *private_data;
} MPIR_UHANDLE;



union MPIR_HANDLE {
    MPIR_OPTYPE type;            
    MPIR_COMMON  chandle;        
    MPIR_SHANDLE shandle;
    MPIR_RHANDLE rhandle;
    MPIR_UHANDLE uhandle;
};




























 
typedef enum {
    MPIR_QSHANDLE,
    MPIR_QRHANDLE
} MPIR_QEL_TYPE;

typedef struct _MPIR_QEL {   
    void *ptr;               
    int  context_id, 
         tag, tagmask,
         lsrc, srcmask;
    MPIR_QEL_TYPE qel_type;  
    struct _MPIR_QEL *prev;  
    struct _MPIR_QEL *next;  
    struct _MPIR_QEL *deliv_next;    
} MPIR_QEL;

typedef struct {         
    MPIR_QEL *first;         
    MPIR_QEL *last;          
    MPIR_QEL *deliv_first;   
    MPIR_QEL *deliv_last;    
    int      currlen;        
    int      maxlen;         
         
} MPIR_QHDR;

 
typedef struct _MPIR_FDTEL {     
    MPIR_NODETYPE      type;     
    int                disp;     
    struct _MPIR_FDTEL *next;    
} MPIR_FDTEL;



 

 
extern void *MPIR_shandles;      
extern void *MPIR_rhandles;      
extern void *MPIR_errhandlers;   
extern void *MPIR_dtes;    
extern void *MPIR_qels;    
extern void *MPIR_fdtels;  
extern void *MPIR_hbts;    
extern void *MPIR_hbt_els; 
extern void *MPIR_topo_els; 

 
extern MPIR_QHDR MPIR_posted_recvs;
extern MPIR_QHDR MPIR_unexpected_recvs;



 
extern MPIR_COLLOPS * MPIR_inter_collops;    
extern MPIR_COLLOPS * MPIR_intra_collops;    

 

 
extern int MPIR_tid;

 

extern int MPIR_F_TRUE, MPIR_F_FALSE;







 



# 304 "../../include/mpir.h"

 
extern void *MPIR_F_MPI_BOTTOM;




 
 







 

# 326 "../../include/mpir.h"
typedef char *MPID_FCHAR_T;







 






 








 


 

 

 





      

# 368 "../../include/mpir.h"

# 378 "../../include/mpir.h"


# 383 "../../include/mpir.h"

# 394 "../../include/mpir.h"





 

# 403 "../../include/mpir.h"

# 415 "../../include/mpir.h"

# 421 "../../include/mpir.h"

# 426 "../../include/mpir.h"





















 

# 465 "../../include/mpir.h"



# 470 "../../include/mpir.h"


# 473 "../../include/mpir.h"
     

# 476 "../../include/mpir.h"
     

# 480 "../../include/mpir.h"
     

# 484 "../../include/mpir.h"

# 486 "../../include/mpir.h"

# 488 "../../include/mpir.h"

# 491 "../../include/mpir.h"

# 494 "../../include/mpir.h"

# 497 "../../include/mpir.h"

# 500 "../../include/mpir.h"

# 505 "../../include/mpir.h"

# 508 "../../include/mpir.h"

# 511 "../../include/mpir.h"

# 514 "../../include/mpir.h"


# 517 "../../include/mpir.h"




# 23 "../../include/mpiimpl.h"

# 1 "../../include/mpi_ad.h"





 

 




 

# 1 "../../include/mpi.h"





 

 


# 204 "../../include/mpi.h"




# 15 "../../include/mpi_ad.h"

# 1 "../../include/dmpi.h"





 

 

 


# 35 "../../include/dmpi.h"


# 16 "../../include/mpi_ad.h"

 

struct MPIR_OP {
  MPI_User_function *op;
   unsigned long cookie;  
  int               commute;
  int               permanent;
};







# 24 "../../include/mpiimpl.h"

# 1 ".//mpid.h"





 


# 25 "../../include/mpiimpl.h"

 

# 32 "../../include/mpiimpl.h"





 

# 1 "../../include/mpiprof.h"



 

# 141 "../../include/mpiprof.h"

# 39 "../../include/mpiimpl.h"



 

# 52 "../../include/mpiimpl.h"

 

# 57 "../../include/mpiimpl.h"









 

# 70 "../../include/mpiimpl.h"



# 80 "../../include/mpiimpl.h"




 

 

 
int MPIR_Attr_copy_node( MPI_Comm, MPI_Comm, MPIR_HBT_node * );
int MPIR_Attr_copy_subtree ( MPI_Comm, MPI_Comm, MPIR_HBT *, MPIR_HBT_node * );
int MPIR_Attr_copy( MPI_Comm, MPI_Comm );
int MPIR_Attr_free_node( MPI_Comm, MPIR_HBT_node * );
int MPIR_Attr_free_subtree( MPI_Comm, MPIR_HBT_node * );
int MPIR_Attr_free_tree( MPI_Comm );
int MPIR_Attr_dup_tree( MPI_Comm, MPI_Comm );
int MPIR_Attr_create_tree( MPI_Comm );
int MPIR_Keyval_create ( MPI_Copy_function   *, MPI_Delete_function *, 
			int *, void *, int );
int MPIR_Comm_make_coll( MPI_Comm, MPIR_COMM_TYPE );
int MPIR_Comm_N2_prev( MPI_Comm, int * );
int MPIR_Dump_comm( MPI_Comm );
int MPIR_Intercomm_high( MPI_Comm, int * );
MPI_Group MPIR_CreateGroup( int );
void MPIR_FreeGroup( MPI_Group );
void MPIR_SetToIdentity( MPI_Group );

# 110 "../../include/mpiimpl.h"
int MPIR_Dump_group( MPI_Group );
int MPIR_Dump_ranks( int, int * );
int MPIR_Dump_ranges( int, int * );
int MPIR_Powers_of_2( int, int *, int * );
int MPIR_Group_N2_prev( MPI_Group, int * );
int MPIR_Sort_split_table( int, int, int *, int *, int * );
int MPIR_Context_alloc( MPI_Comm, int, MPIR_CONTEXT * );
int MPIR_Context_dealloc( MPI_Comm, int, MPIR_CONTEXT );
int MPIR_dup_fn ( MPI_Comm *, int *, void *, void *, void *, int * );

 
int MPIR_Pack ( MPI_Comm, void *, int, MPI_Datatype, void *, int, int *);
int MPIR_Pack_size ( int, MPI_Datatype, MPI_Comm, int *);
int MPIR_Unpack( MPI_Comm, void *, int, int, MPI_Datatype, int, 
		 void *, int *, int * );
int MPIR_UnPackMessage( char *, int, MPI_Datatype, int, MPI_Request, int * );
int MPIR_Type_free( MPI_Datatype * );
void MPIR_Type_free_struct( MPI_Datatype );
MPI_Datatype MPIR_Type_dup( MPI_Datatype );
int MPIR_Type_permanent( MPI_Datatype );
void MPIR_Type_get_limits( MPI_Datatype, MPI_Aint *, MPI_Aint *);
int MPIR_Send_init( void *, int, MPI_Datatype, int, int, MPI_Comm, 
		     MPI_Request, MPIR_Mode, int );

 
void MPIR_BSwap_N_inplace( unsigned char *, int, int );
void MPIR_BSwap_short_inplace( unsigned char *, int );
void MPIR_BSwap_int_inplace( unsigned char *, int );
void MPIR_BSwap_long_inplace( unsigned char *, int );
void MPIR_BSwap_float_inplace( unsigned char *, int );
void MPIR_BSwap_double_inplace( unsigned char *, int );
void MPIR_BSwap_long_double_inplace( unsigned char *, int );
void MPIR_BSwap_N_copy( unsigned char *, unsigned char *, int, int );
void MPIR_BSwap_short_copy( unsigned char *, unsigned char *, int );
void MPIR_BSwap_int_copy( unsigned char *, unsigned char *, int );
void MPIR_BSwap_long_copy( unsigned char *, unsigned char *, int );
void MPIR_BSwap_float_copy( unsigned char *, unsigned char *, int );
void MPIR_BSwap_double_copy( unsigned char *, unsigned char *, int );
void MPIR_BSwap_long_double_copy( unsigned char *, unsigned char *, int );

int MPIR_Type_swap_copy( unsigned char *, unsigned char *, MPI_Datatype, 
			  int, void * );
void MPIR_Type_swap_inplace( unsigned char *, MPI_Datatype, int );
int MPIR_Type_XDR_encode( unsigned char *, unsigned char *, MPI_Datatype, 
			  int, void * );
int MPIR_Type_XDR_decode( unsigned char *, int, MPI_Datatype, int, 
			  unsigned char *, int *, int *, void * );
int MPIR_Type_convert_copy( MPI_Comm, void *, int, void *, MPI_Datatype, 
			   int, int, int * );
int MPIR_Comm_needs_conversion( MPI_Comm );
int MPIR_Dest_needs_converstion( int );
void MPIR_Pack_Hvector( MPI_Comm, char *, int, MPI_Datatype, int, char * );
void MPIR_UnPack_Hvector( char *, int, MPI_Datatype, int, char * );
int MPIR_HvectorLen( int, MPI_Datatype );
int MPIR_PackMessage( char *, int, MPI_Datatype, int, MPI_Request );
int MPIR_EndPackMessage( MPI_Request );
int MPIR_SetupUnPackMessage( char *, int, MPI_Datatype, int, MPI_Request );
int MPIR_Receive_setup( MPI_Request * );
int MPIR_Send_setup( MPI_Request * );
int MPIR_SendBufferFree( MPI_Request );

void DMPI_msg_arrived( int, int, MPIR_CONTEXT, MPIR_RHANDLE **, int * );
void DMPI_free_unexpected( MPIR_RHANDLE      * );

 
MPI_Datatype MPIR_Init_basic_datatype( MPIR_NODETYPE, int );

 
int MPIR_Topology_copy_fn( MPI_Comm *, int *, void *, void *, void *, int * );
int MPIR_Topology_delete_fn( MPI_Comm *, int *, void *, void * );

 



 
void MPIR_dump_rhandle( MPIR_RHANDLE );
void MPIR_dump_shandle( MPIR_SHANDLE );
void MPIR_dump_queue( MPIR_QHDR * );
int MPIR_enqueue( MPIR_QHDR *, MPIR_COMMON *, MPIR_QEL_TYPE );
int MPIR_dequeue( MPIR_QHDR *, void * );
int MPIR_search_posted_queue( int, int, MPIR_CONTEXT, int *, int, 
			     MPIR_RHANDLE ** );
int MPIR_search_unexpected_queue( int, int, MPIR_CONTEXT, int *, int, 
				 MPIR_RHANDLE ** );
int MPIR_dump_dte( MPI_Datatype, int );
int MPIR_flatten_dte( MPI_Datatype, MPIR_FDTEL **, MPIR_FDTEL ***, int * );
int MPIR_dump_flat_dte( MPIR_FDTEL * );
int MPIR_Tab( int );

int  MPIR_SetBuffer( void *, int );
void MPIR_FreeBuffer( void **, int *);
void MPIR_PrepareBuffer( MPIR_SHANDLE * );
int MPIR_GetBuffer( int, MPI_Request, void *, int, MPI_Datatype, void ** );
void MPIR_BufferFreeReq( MPIR_SHANDLE * );


# 210 "../../include/mpiimpl.h"





# 12 "./mpid.h"


 




# 1 "./packets.h"



 


















 































 






















 















 










 
typedef enum { MPID_PKT_SHORT=0, MPID_PKT_LONG=1, MPID_PKT_SHORT_SYNC=2,
	       MPID_PKT_LONG_SYNC=3, MPID_PKT_SHORT_READY=4, 
               MPID_PKT_LONG_READY=5, 
               MPID_PKT_REQUEST_SEND=6,
	       MPID_PKT_REQUEST_SEND_READY=7,
	       MPID_PKT_DO_GET=8, MPID_PKT_DO_GET_SYNC=9,
               MPID_PKT_OK_TO_SEND=10, MPID_PKT_SYNC_ACK=11, 
	       MPID_PKT_READY_ERROR=12, 
               MPID_PKT_DONE_GET = 13, MPID_PKT_CONT_GET = 14,
	       MPID_PKT_COMPLETE_SEND=15, MPID_PKT_COMPLETE_RECV=16 }
    MPID_Pkt_t;

 
   

# 128 "./packets.h"










 

# 144 "./packets.h"






# 152 "./packets.h"




# 158 "./packets.h"








# 182 "./packets.h"

 

# 190 "./packets.h"

# 197 "./packets.h"




 





 

# 212 "./packets.h"



# 217 "./packets.h"













 

 
typedef struct {
       int mode:32;       
    } MPID_PKT_MODE_T;

 
typedef struct {
        int mode:32;        int context_id:32; int lrank:32; int tag:32; int len:32;   
    } MPID_PKT_HEAD_T;
typedef struct { 
        int mode:32;        int context_id:32; int lrank:32; int tag:32; int len:32;   
    char     buffer[ 1024 ];
    } MPID_PKT_SHORT_T;
typedef struct {
        int mode:32;        int context_id:32; int lrank:32; int tag:32; int len:32;   
    } MPID_PKT_LONG_T;
typedef struct { 
        int mode:32;        int context_id:32; int lrank:32; int tag:32; int len:32;   
    char     buffer[ 1024 ];
    } MPID_PKT_SHORT_READY_T;
typedef struct {
        int mode:32;        int context_id:32; int lrank:32; int tag:32; int len:32;   
    } MPID_PKT_LONG_READY_T;

typedef struct {
        int mode:32;        int context_id:32; int lrank:32; int tag:32; int len:32;   
    MPID_Aint sync_id;
    char      buffer[ 1024 ];
    } MPID_PKT_SHORT_SYNC_T;
typedef struct {
        int mode:32;        int context_id:32; int lrank:32; int tag:32; int len:32;   
    MPID_Aint sync_id;
    } MPID_PKT_LONG_SYNC_T;

typedef struct {
       int mode:32;       
    MPID_Aint sync_id;
    } MPID_PKT_SYNC_ACK_T;

typedef struct {
       int mode:32;       
    MPID_Aint send_id;
    } MPID_PKT_COMPLETE_SEND_T;
typedef struct {
       int mode:32;       
    MPID_Aint recv_id;
    } MPID_PKT_COMPLETE_RECV_T;
typedef struct {
        int mode:32;        int context_id:32; int lrank:32; int tag:32; int len:32;   
    MPID_Aint   send_id;          
    MPID_RNDV_T send_handle;      
    } MPID_PKT_REQUEST_SEND_T;
typedef struct {
        int mode:32;        int context_id:32; int lrank:32; int tag:32; int len:32;   
    MPID_Aint   send_id;
    MPID_RNDV_T send_handle;
    } MPID_PKT_REQUEST_SEND_READY_T;
typedef struct {
       int mode:32;       
    MPID_Aint   send_id;         
    MPID_RNDV_T recv_handle;     
    } MPID_PKT_OK_TO_SEND_T;

typedef struct {
        int mode:32;        int context_id:32; int lrank:32; int tag:32; int len:32;   
    } MPID_PKT_READY_ERROR_T;



 
typedef struct {
        int mode:32;        int context_id:32; int lrank:32; int tag:32; int len:32;   
    MPID_Aint    send_id;        
    MPID_Aint    recv_id;        
    void         *address;       
     
    int          len_avail;      
    int          cur_offset;     
     
    MPID_Aint    sync_id;       
 
    } MPID_PKT_GET_T;
 


 




typedef union _MPID_PKT_T {
    MPID_PKT_HEAD_T          head;
    MPID_PKT_SHORT_T         short_pkt;
    MPID_PKT_SHORT_SYNC_T    short_sync_pkt;
    MPID_PKT_SHORT_READY_T   short_ready_pkt;
    MPID_PKT_REQUEST_SEND_T  request_pkt;
    MPID_PKT_REQUEST_SEND_T  request_ready_pkt;
    MPID_PKT_OK_TO_SEND_T    sendok_pkt;
    MPID_PKT_LONG_T          long_pkt;
    MPID_PKT_LONG_SYNC_T     long_sync_pkt;
    MPID_PKT_LONG_READY_T    long_ready_pkt;
    MPID_PKT_SYNC_ACK_T      sync_ack_pkt;
    MPID_PKT_COMPLETE_SEND_T send_pkt;
    MPID_PKT_COMPLETE_RECV_T recv_pkt;
    MPID_PKT_READY_ERROR_T   error_pkt;
    MPID_PKT_GET_T           get_pkt;
    char                     pad[ 8 ];
    } MPID_PKT_T;
























































 

extern FILE *MPID_TRACE_FILE;



# 404 "./packets.h"

# 408 "./packets.h"

# 412 "./packets.h"


# 1 "./channel.h"




# 1 "/usr/transputer/parix1.2/include/stdio.h"




 


# 5 "./channel.h"

# 1 "/usr/transputer/parix1.2/include/sys/root.h"











 





 



# 1 "/usr/transputer/parix1.2/include/stdarg.h"


 






 
 




typedef	char	*va_list;








# 22 "/usr/transputer/parix1.2/include/sys/root.h"



# 1 "/usr/transputer/parix1.2/include/sys/param.h"









 




 




# 22 "/usr/transputer/parix1.2/include/sys/param.h"










# 33 "/usr/transputer/parix1.2/include/sys/param.h"







 





 

 









 




 



 
# 25 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/types.h"









 


typedef unsigned char	byte;
typedef unsigned int	uint;
typedef unsigned short	ushort;
typedef unsigned long	ulong;

typedef long	daddr_t;  	 
typedef	char *	paddr_t;	 
typedef char *	caddr_t;  	 
typedef char *	uaddr_t;  	 
typedef ushort	ino_t;     	 

# 1 "/usr/transputer/parix1.2/include/sys/time_t.h"


 




typedef long	time_t;


# 24 "/usr/transputer/parix1.2/include/sys/types.h"
typedef short	dev_t;		 
typedef long	off_t;    	 

# 1 "/usr/transputer/parix1.2/include/sys/size_t.h"


 


# 27 "/usr/transputer/parix1.2/include/sys/types.h"

# 1 "/usr/transputer/parix1.2/include/sys/clock_t.h"


 




typedef unsigned long	clock_t;	 


# 28 "/usr/transputer/parix1.2/include/sys/types.h"
typedef ushort	gid_t;		 
typedef ushort	pid_t;		 
typedef ushort	uid_t;		 
typedef ushort	mode_t;		 
typedef ushort	nlink_t;	 

typedef ushort	pri_t;		 
typedef ushort	id_t;		 
typedef long	key_t;		 
typedef long	reg_t;		 
typedef ushort	imode_t;	 
typedef ulong	clkl_t;		 
typedef ulong	clka_t;		 
typedef ulong	swpl_t;		 
typedef ulong	swpb_t;		


 



 
union	combin {
	char	chr;
	byte	bt;
	short	shrt;
	ushort	ushrt;
	long	lng;
	ulong	ulng;
} ;



 
struct vector {
	short	number;
	caddr_t	pointer;
} ;










 




typedef int		word;
typedef unsigned int	Channel_t;


typedef unsigned char	u_char;
typedef unsigned short	u_short;
typedef unsigned int	u_int;
typedef unsigned long	u_long;

struct iovec {
    caddr_t         iov_base;
    int             iov_len;
};



 

typedef struct fd_set {
    int             fds_bits[2];
}               fd_set;






# 109 "/usr/transputer/parix1.2/include/sys/types.h"

# 111 "/usr/transputer/parix1.2/include/sys/types.h"

# 113 "/usr/transputer/parix1.2/include/sys/types.h"

# 115 "/usr/transputer/parix1.2/include/sys/types.h"



 


# 26 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/list.h"








 





 



 

typedef struct Node {
    struct Node    *Next;
    struct Node    *Prev;
}               Node_t;



 

typedef struct {
    Node_t         *Head;
    Node_t         *Null;
    Node_t         *Tail;
}               List_t;
 






 

typedef int     (*ListFunc_t) (Node_t *,...);


extern void     InitList (List_t *);
extern void     AddHead (List_t *, Node_t *);
extern void     AddTail (List_t *, Node_t *);
extern void     PreInsert (Node_t *, Node_t *);
extern void     PostInsert (Node_t *, Node_t *);
extern Node_t  *Remove (Node_t *);
extern Node_t  *RemHead (List_t *);
extern Node_t  *RemTail (List_t *);
extern Node_t  *SearchList (List_t *, ListFunc_t fn,...);
extern int      WalkList (List_t *, ListFunc_t fn,...);


# 79 "/usr/transputer/parix1.2/include/sys/list.h"



 
# 27 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/sem.h"








 





# 1 "/usr/transputer/parix1.2/include/sys/types.h"

# 15 "/usr/transputer/parix1.2/include/sys/sem.h"

 





 

typedef struct Loc {
    int		    wptr;
    struct Loc	   *next;
}		Loc_t;



 

typedef struct {
    int		    Count;
    void	   *Head;
    void	   *Tail;
    Channel_t	    Lock;
}		Semaphore_t;


 



extern void	InitSem (Semaphore_t *, int);
extern void	Wait (Semaphore_t *);
extern void	Signal (Semaphore_t *);
extern int	TestWait (Semaphore_t *);
extern void	WaitFirst (Semaphore_t *);


# 60 "/usr/transputer/parix1.2/include/sys/sem.h"



 
# 28 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/thread.h"


















 




 


# 1 "/usr/transputer/parix1.2/include/sys/sem.h"








 


# 62 "/usr/transputer/parix1.2/include/sys/sem.h"

 
# 27 "/usr/transputer/parix1.2/include/sys/thread.h"

# 1 "/usr/transputer/parix1.2/include/setjmp.h"









 


# 15 "/usr/transputer/parix1.2/include/setjmp.h"


# 19 "/usr/transputer/parix1.2/include/setjmp.h"






# 27 "/usr/transputer/parix1.2/include/setjmp.h"

typedef int	jmp_buf[ 36  ];
typedef int	sigjmp_buf[ 36  ];


# 35 "/usr/transputer/parix1.2/include/setjmp.h"
extern int setjmp(jmp_buf _env);
extern void longjmp(jmp_buf _env, int _val);



# 28 "/usr/transputer/parix1.2/include/sys/thread.h"


 



 
typedef struct {
    int		    Magic;
    byte	   *DataLo;
    byte	   *DataHi;
    byte	   *StackLo;
    byte	   *StackHi;
    byte	   *StackOvfl;
    byte	   *TextLo;
    byte	   *TextHi;
    byte           *StackClass;
}		MDL_t;



 
typedef struct {
    Node_t	    link;		 
    MDL_t	    MDL;		 
    int		    Errno;		 
    int		    Signgam;		 
    int		    status;		 
					 
    int		    tsw;		 
    Semaphore_t	    terminate;		 
    int		    DebugFlag;		 
    int		    DebugWptr;		 
    void	   *DebugPtr;
    jmp_buf	    JumpBuf;		 
}		Thread_t;














 


extern Thread_t *_RunThread (int (*) (), int, byte *, int *, int,...);
extern Thread_t *StartThread (int (*) (), int, int *, int,...);
extern Thread_t *WaitThread (Thread_t *, void *);
extern Thread_t *GetThreadPtr (void);
extern int	ChangePriority (int);
extern int	_GetPriority (void);


# 98 "/usr/transputer/parix1.2/include/sys/thread.h"



 
# 29 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/context.h"












 




 


# 1 "/usr/transputer/parix1.2/include/sys/list.h"








 


# 81 "/usr/transputer/parix1.2/include/sys/list.h"

 
# 21 "/usr/transputer/parix1.2/include/sys/context.h"

# 1 "/usr/transputer/parix1.2/include/sys/sem.h"








 


# 62 "/usr/transputer/parix1.2/include/sys/sem.h"

 
# 22 "/usr/transputer/parix1.2/include/sys/context.h"

# 1 "/usr/transputer/parix1.2/include/sys/thread.h"


















 


# 100 "/usr/transputer/parix1.2/include/sys/thread.h"

 
# 23 "/usr/transputer/parix1.2/include/sys/context.h"


 






 




# 38 "/usr/transputer/parix1.2/include/sys/context.h"




 








 










 












 















 






 
typedef struct {
    byte            Hdr [ ( 20  +  32  + (3 *  42 )) ];
} COFF_t;



 
typedef struct {
    byte            Rel [ 10 ];
} Reloc_t;




 

typedef struct {
    int             f_magic;
    int             f_nscns;
    int             f_timdat;
    int             f_symptr;
    int             f_nsyms;
    int             f_opthdr;
    int             f_flags;
} PFileHdr_t;

typedef struct {
    int             magic;
    int             vstamp;
    int             tsize;
    int             dsize;
    int             bsize;
    int             entry;
    int             text_start;
    int             data_start;
    int             ssize;
} PAOutHdr_t;

typedef struct {
    char            s_name [8];
    int             s_paddr;
    int             s_vaddr;
    int             s_size;
    int             s_scnptr;
    int             s_relptr;
    int             s_lnnoptr;
    int             s_nreloc;
    int             s_nlnno;
    int             s_attrs;
    int             s_type;
    int             s_vstamp;
} PScnHdr_t;

typedef struct {
    int             r_vaddr;
    int             r_symndx;
    int             r_type;
} PReloc_t;




 
typedef struct {
    PFileHdr_t      FileHdr;
    PAOutHdr_t      AOutHdr;
    PScnHdr_t       DataHdr;
    PScnHdr_t       BssHdr;
    PScnHdr_t       TextHdr;
} PCOFF_t;

typedef enum   {MINUS_X, MINUS_Y, PLUS_X, PLUS_Y} Dir_t;
typedef enum   {REQUESTED, AVAILABLE, INVALID} CCStatus_t;



  
typedef struct {
    char           *tag;
    PCOFF_t        *code;
    int             code_size;
    int             nAccess;
    int             nPackets;
    int             nUser;
    CCStatus_t      status;
    Semaphore_t     ready;
} CodeCB_t;



 

typedef struct {
    Node_t          link;            
    List_t          MemBlocks;       
    List_t          threads;         
    int             nThread;         
    Semaphore_t     any_terminate;
    PCOFF_t        *code;            
    byte           *stack_addr;
    int             stack_size;
    byte           *static_addr;
    int             static_size;
    byte           *text_addr;
    int             text_size;
    int             id;              
} Context_t;




 

typedef struct {
    char          **ArgV;            
    char          **EnvV;            
    char          **DirV;            
    void           *LinkV;           
    void           *TopV;            
} Environ_t;



 
extern Environ_t * parix_environ;

 



extern int         _InitCacheHandling (void);
extern Thread_t *  _InitContext (Context_t *);
extern void        _FreeContext (Context_t *);
extern Thread_t *  _InitThread (Context_t *, int *);
extern int         RunMain (COFF_t *, Environ_t *);
extern int         Execute (char *, Environ_t *);
extern void        Exit (int);


# 248 "/usr/transputer/parix1.2/include/sys/context.h"



 
# 30 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/link.h"









 




 


# 1 "/usr/transputer/parix1.2/include/sys/sem.h"








 


# 62 "/usr/transputer/parix1.2/include/sys/sem.h"

 
# 18 "/usr/transputer/parix1.2/include/sys/link.h"

# 1 "/usr/transputer/parix1.2/include/sys/context.h"












 


# 250 "/usr/transputer/parix1.2/include/sys/context.h"

 
# 19 "/usr/transputer/parix1.2/include/sys/link.h"

# 1 "/usr/transputer/parix1.2/include/sys/types.h"

# 20 "/usr/transputer/parix1.2/include/sys/link.h"

 









 

typedef struct {
    Semaphore_t     SendLock;
    Semaphore_t     RecvLock;
    Context_t      *Owner;
    Channel_t      *Send;
    Channel_t      *Recv;
}               LinkCB_t;


 


extern LinkCB_t *MakeLink (int, int, int *);
extern LinkCB_t *GetLink (int, int, int *);
extern LinkCB_t *ConnectLink (int, int, int *);
extern int      BreakLink (LinkCB_t *);

extern int      SendLink (LinkCB_t *, void *, int);
extern int      RecvLink (LinkCB_t *, void *, int);


# 64 "/usr/transputer/parix1.2/include/sys/link.h"



 
# 31 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/vlink.h"









 




 


 












 

typedef struct {
    int             status;		 
    int             header;		
 
    Channel_t       ctrlin;		
 
    Channel_t       ctrlout;		
 
    byte           *outbuf;		
 
    int             outlimit;		 
    byte           *inbuf;		
 
    int             inlimit;		 
    void           *RCptr;		 
    int             RCid;		 

    int		    select_ws[5];

    byte            buffer[ 120 ];	 
}               VLCB_t;



 



# 62 "/usr/transputer/parix1.2/include/sys/vlink.h"





 

# 70 "/usr/transputer/parix1.2/include/sys/vlink.h"

# 72 "/usr/transputer/parix1.2/include/sys/vlink.h"

# 74 "/usr/transputer/parix1.2/include/sys/vlink.h"


 


# 80 "/usr/transputer/parix1.2/include/sys/vlink.h"

# 82 "/usr/transputer/parix1.2/include/sys/vlink.h"

# 84 "/usr/transputer/parix1.2/include/sys/vlink.h"











 

typedef struct {
    Channel_t       in;			 
    Channel_t       out;		 


    Channel_t       select;		
 

}               VLink_t;



 

typedef struct {
    byte           *BuffPtr;
    int             BuffSize;
}               CommArgs_t;



 

typedef struct {
    int             LowerBound;
    int             UpperBound;
    int             PhysOutLink;
}               Intervall_t;



 


extern int      AllocVLink (void);
extern int      FreeVLink (int);
extern int      SetHeader (int, byte *, int);
extern int      GetHeader (int, byte *, int *);

extern int      StopChannel (int, int);
extern int      ResetChannel (int, int);
extern int      InspectHeader (int, byte *, int *);


# 152 "/usr/transputer/parix1.2/include/sys/vlink.h"



 
# 32 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/llink.h"








 




 

typedef struct {
    Channel_t       Chan1;
    Channel_t       Chan2;
}               LLink_t;

 


extern int      AllocLLink (void);
extern int      FreeLLink (int);


# 33 "/usr/transputer/parix1.2/include/sys/llink.h"



 
# 33 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/rlink.h"











 




 



 

typedef struct {
    int             RDSf;
    int             RDSb;
    int             RDSpw;
}               RDS_t;



 

typedef struct {
    int             ServiceId;
    Context_t      *Owner;
    void           *RDSf;
    void           *RDSb;
    Channel_t       RDSpw;
    Thread_t       *Thread;
    Semaphore_t	    Sem;
}               ServiceCB_t;



 

typedef struct {
    ServiceCB_t    *Server;
    Channel_t       AckChan;
    Channel_t       ReqChan;
    void           *RCptr;
    int             RCid;
}               RLink_t;


 


extern int      AllocRLink (void);
extern int      FreeRLink (int);

extern ServiceCB_t *InitService (int, int *);
extern LinkCB_t *ConnectService (int, int, int *);
extern int      DisconnectService (int, int, LinkCB_t *);
extern LinkCB_t *GrantService (ServiceCB_t *, int *);
extern int      UnGrantService (ServiceCB_t *, LinkCB_t *);
extern int      FreeService (ServiceCB_t *);


# 82 "/usr/transputer/parix1.2/include/sys/rlink.h"



 
# 34 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/select.h"








 




 

typedef struct {
    int             Tag;
    union {
	Channel_t      *Chan;
	RDS_t          *RDS;
	time_t          Time;
    }               Val;
}               Option_t;

 


extern int      Select (int, Option_t,...);
extern int      CondSelect (int, Option_t,...);
extern int      SelectList (int, Option_t *);
extern int      CondSelectList (int, Option_t *);

extern Option_t ReceiveOption (LinkCB_t *);
extern Option_t TimeAfterOption (time_t);
extern Option_t GrantOption (ServiceCB_t);


# 49 "/usr/transputer/parix1.2/include/sys/select.h"



 
# 35 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/linkroot.h"








 




 



 

typedef struct {



    VLCB_t         *VLCBs;		
				 
    VLink_t        *VLinks;		 
    int             NoIntervalls;	 
    Intervall_t    *Intervalls;		 
    Semaphore_t     LinkSems[ 4 ];
					  
					  



    LLink_t        *LLinks;		 
    RLink_t        *RLinks;		 
    LinkCB_t       *LinkCBs;		 
    ServiceCB_t    *ServiceCBs;		 

    int             CountOfVLinks;
    int             CountOfLLinks;
    int             CountOfRLinks;

    int             CountOfServiceCBs;

    LinkCB_t       *StartVLinks;	 
    LinkCB_t       *StartLLinks;
    LinkCB_t       *StartRLinks;

    LinkCB_t       *VLinkFreeList;	 
    LinkCB_t       *LLinkFreeList;
    LinkCB_t       *RLinkFreeList;

}               RootLink_t;



 
# 36 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/memory.h"











 




 


# 1 "/usr/transputer/parix1.2/include/stddef.h"




 





# 1 "/usr/transputer/parix1.2/include/null.h"


 


# 11 "/usr/transputer/parix1.2/include/stddef.h"



typedef int	ptrdiff_t;	 


# 1 "/usr/transputer/parix1.2/include/sys/size_t.h"


 


# 17 "/usr/transputer/parix1.2/include/stddef.h"


# 1 "/usr/transputer/parix1.2/include/sys/wchar_t.h"


 




typedef char	wchar_t;	 


# 19 "/usr/transputer/parix1.2/include/stddef.h"


# 20 "/usr/transputer/parix1.2/include/sys/memory.h"

# 1 "/usr/transputer/parix1.2/include/sys/types.h"

# 21 "/usr/transputer/parix1.2/include/sys/memory.h"

# 1 "/usr/transputer/parix1.2/include/sys/sem.h"








 


# 62 "/usr/transputer/parix1.2/include/sys/sem.h"

 
# 22 "/usr/transputer/parix1.2/include/sys/memory.h"

 

 








 




 

typedef struct header {
    size_t          size;		 
    struct header  *left;		 
    struct header  *right;		
 
}               header_t;

 

typedef struct {
    int             arena;		 
    int             freearena;		 
    int             usedblocks;		 
    int             freeblocks;		 
}               mallinfo_t;

 

typedef struct {
    byte           *MemStart;		 
    byte           *MemEnd;		 
    mallinfo_t      info;		 
    header_t        _dummy;		
 
    header_t       *_freelist;		 
    Semaphore_t	   Lock;		 
}               MemoryCB_t;

 

typedef struct {
    MemoryCB_t	   MemBank[ 2 ];
}		RootMemory_t;

 



extern void		*Malloc (size_t, int);
extern void		*Calloc (size_t, size_t, int);
extern void		*Realloc (void *, size_t, int);
extern void		Free (void *);
extern mallinfo_t	MallInfo (int);
extern size_t           MallSize (void *);
extern void		_MemInit (byte *, byte *, int);


# 98 "/usr/transputer/parix1.2/include/sys/memory.h"



 
# 37 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/boot.h"








 




 


# 1 "/usr/transputer/parix1.2/include/sys/link.h"









 


# 66 "/usr/transputer/parix1.2/include/sys/link.h"

 
# 17 "/usr/transputer/parix1.2/include/sys/boot.h"

 






 

typedef struct {
    int             x;
    int             y;
    int             z;
}               Pos_t;



 

typedef struct {
    Pos_t           proc;
    int             link;
}               HostPos_t;



 

typedef struct {
    int             MyProcID;		 
    int             MyX;		 
    int             MyY;		 
    int             MyZ;		 
    int             nProcs;		 
    int             DimX;		 
    int             DimY;		 
    int             DimZ;		 
}               RootProc_t;





 

typedef struct {
    Pos_t           Proc;		
 
    int             LinkNo;		
 
    int             ID;			 
    int             ByteOrder;
    int             MaxCSize;		 
    int             MaxDSize;		 
					 
                                         
    char           *name;		 
}               HostInfo_t;




 

typedef struct {
    LinkCB_t       *Link;
    HostInfo_t     *Host;
}               HostLinkCB_t;





 

typedef struct {
    int             nHosts;		 
    HostInfo_t     *Hosts;		 
    HostLinkCB_t   *HostLinks;
}               RootHosts_t;







 







 
# 38 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/topology.h"








 




 



 





 



 
typedef struct {
    Semaphore_t async_sem;
    int async_cnt;
    int comm_cnt;
} ACControl_t;



 
typedef struct ATData_t {
    Semaphore_t for_work;
    ACControl_t *acc;
    LinkCB_t *link;
    int *result;
    byte *data;
    int size;
    int ifbuffer;
    int action;
    Thread_t *tp;
} ATData_t;



 
typedef struct ASyncData_t {
    Semaphore_t lock;
    int n_acc;
    ACControl_t acc0;
    ACControl_t *acc;
    int size;
    int used_size;
    int	n_threads;
    int	n_threads_const;
    int p_ready_thread;
    ATData_t **ready_thread;
} ASyncData_t;

typedef struct Topology_t {
    Semaphore_t     Lock;
    LinkCB_t      **Links;		 
    void           *UserData;
    ASyncData_t    *ad;
    int             MyId;
    int             MaxLinks;
    int             UsedLinks;
    Context_t      *Owner;
}               Topology_t;

typedef struct {
    Topology_t    **Tops;		 
    int             nTops;		 
    int             uTops;		 
    Semaphore_t     Lock;		 
}               RootTops_t;

 


extern int      NewTop (int TopId);
extern int      AddTop (int TopId, LinkCB_t * Link);
extern int      AddTop_Data (int TopId, void *Data);
extern void    *GetTop_Data (int TopId, int *Err_code);
extern LinkCB_t *GetLinkCB (int TopId, int LogLinkId, int *Err_code);
extern int      FreeTop (int TopId);


# 104 "/usr/transputer/parix1.2/include/sys/topology.h"



 
# 39 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/logerror.h"








 





# 1 "/usr/transputer/parix1.2/include/stdarg.h"


 






 
 


# 15 "/usr/transputer/parix1.2/include/sys/logerror.h"

 










typedef struct {
    Semaphore_t     Lock;
    char            Text[1024];
    char            Fmt[256];
}               RootLogger_t;

 


extern int	vsprintd (char *Buffer, int BufSize, 
			  char *Format, va_list args);
extern int	sprintd (char *Buffer, int BufSize, 
			 char *Format, ...);
extern void	printd (char *Format, ...);
extern void	printe (char *Format, ...);
extern void     LogError (int ErrCode, char *FName, char *Format,...);


# 53 "/usr/transputer/parix1.2/include/sys/logerror.h"



 
# 40 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/rrouter.h"

















 




 



 









 






 






 









 






 






 







 







 





 

typedef struct {
    int             Size;
    int             DestProcId;
    int             ReqId;
    int             MsgType;
    int             SourceProcId;
    int             Code;
    int             Timeout;
}               RR_Header_t;



 

typedef struct {
    RR_Header_t     Header;
    byte            Body[ 1024  ];
}               RR_Message_t;



 

typedef struct {
    Node_t          Node;
    RR_Message_t    Msg;
}               RR_WaitList_t;



 

typedef struct {
    Node_t          Node;
    RR_Header_t     Header;
    Semaphore_t     Sem;
    RR_WaitList_t  *MsgPointer;
}               RR_RecvWaitList_t;



 

typedef struct {
    Node_t          Node;
    int		    DestId;
    int		    ReqId;
    int		    MsgType;
    int		    Code;
}               RR_ReplyNode_t;



 

typedef struct {
    Semaphore_t     Lock;		 
    int             MailBoxSize;	 
    List_t          MailBox;		 
    List_t          RecvBox;		 
    List_t	    ReplyBox;		 
    Topology_t     *MyTop;		 
    int            (*RoutingDirection) ();
    Semaphore_t	    ReplySync;		 
    List_t	    ReplyList;		 
    int		    ReplyCount;		 
    Semaphore_t	    ReplyLock;		 
    Thread_t	   *ReplyThread;	 
}               MailBoxCB_t;



 

typedef struct {
    int             MailBoxCount;	 
    MailBoxCB_t    *MailBoxCBs[ 16 ];
    Semaphore_t	    ConnectLinkSem;	 
}               RootMailBox_t;


 


extern int      UserGetMessage (int, int, int, int, int, RR_Message_t *);
extern int      UserPutMessage (int, int, int, int, int, int, void *, int);
extern int      UserExchangeMessage
                (int, int, int, int, int, int, void *, int, RR_Message_t *);

extern int	GetMessage (int, int, int, int, RR_Message_t *);
extern int	PutMessage (int, int, int, int, int, void *, int);
extern int      ExchangeMessage 
		(int, int, int, int, int, void *, int, RR_Message_t *);

extern int	SysRoutingDirection (int);
extern int      InitUserRouter (int, int (*) ());
extern int      InitMailBoxRoot (void);
extern int	TerminateUserRouter (int);


# 215 "/usr/transputer/parix1.2/include/sys/rrouter.h"



 
# 41 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/rpc.h"










 




 

typedef struct {
    int             LibFunc;
    int             ReplyCSize;
    int             ReplyDSize;
    int             CSize;
    int             DSize;
}               RPC_Request_Header_t;

typedef struct {
    RPC_Request_Header_t Header;
    int            *CVec;
    char           *DVec;
}               RPC_Request_Message_t;

typedef struct {
    int             Result;
    int             CSize;
    int             DSize;
}               RPC_Reply_Header_t;

typedef struct {
    RPC_Reply_Header_t Header;
    int            *CVec;
    char           *DVec;
}               RPC_Reply_Message_t;









# 60 "/usr/transputer/parix1.2/include/sys/rpc.h"


# 65 "/usr/transputer/parix1.2/include/sys/rpc.h"


# 68 "/usr/transputer/parix1.2/include/sys/rpc.h"


# 71 "/usr/transputer/parix1.2/include/sys/rpc.h"

 



extern int 	Transaction (HostLinkCB_t *, RPC_Request_Message_t *,
			     RPC_Reply_Message_t *);
extern void     (InitRequest) (RPC_Request_Message_t * Request,
			       int Lib, int Func, int *CVec, int CSize,
			       char *DVec, int ReplyCSize, int ReplyDSize);
extern void     (InitReply) (RPC_Reply_Message_t * Reply,
			                     int *CVec, char *DVec);
extern int 	CheckRetry (HostLinkCB_t * HostLink,
			    RPC_Reply_Message_t * Reply, char *FName);
extern void     (PutInt) (RPC_Request_Message_t * Request, int Val, int Pos);
extern int      (GetInt) (RPC_Reply_Message_t * Reply, int Pos);
extern void     PutString (RPC_Request_Message_t * Request, char *Str,
			   int Ofs);
extern void     PutOpaque (RPC_Request_Message_t * Request, byte * Buf,
			   int Len, int Ofs);
extern void     SwapInts (int *dest, int *source, int size);


# 102 "/usr/transputer/parix1.2/include/sys/rpc.h"


# 42 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/time.h"








 




 




 
struct timeval {
        long    tv_sec;          
        long    tv_usec;         
};

 



 

 


extern unsigned int TimeNowLow (void);
extern unsigned int TimeNowHigh (void);
extern void     TimeWaitLow (unsigned int);
extern void     TimeWaitHigh (unsigned int);
extern int      TimeAfter (unsigned int time1, unsigned int time2);


# 49 "/usr/transputer/parix1.2/include/sys/time.h"



 
# 43 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/debug.h"














 




 





 











 





typedef struct {
    Semaphore_t     BreakSem;
    List_t          BreakList;
    void            (*DebugHandlerAdr) ();
}               RootDebug_t;

typedef struct ThreadStatus {
    int             RunStatus;
    int             Wptr;
    int             Iptr;
    int             Areg, Breg, Creg;
    double          FAreg, FBreg, FCreg;
}               ThreadStatus_t;

typedef struct DebugPushStruct {
    Node_t          myNode;
    double          FAreg, FBreg, FCreg;
    int             Wptr;
    int             DebugFlag;
    int             old_prio, s[2];	 
}               DebugPushStruct_t;

 



extern int      SetBreak (byte *, byte *);
extern int      ClearBreak (byte *, byte *);
extern Thread_t *WaitBreak (ThreadStatus_t *);
extern int      ContinueBreak (Thread_t *, ThreadStatus_t *);
extern int      StepThread (Thread_t *, ThreadStatus_t *, int);
extern void     DebugHandler (int, int, int);
extern int      InitDebugRoot (void);


# 89 "/usr/transputer/parix1.2/include/sys/debug.h"



 
# 44 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/rootcontext.h"










 




 


# 1 "/usr/transputer/parix1.2/include/sys/list.h"








 


# 81 "/usr/transputer/parix1.2/include/sys/list.h"

 
# 19 "/usr/transputer/parix1.2/include/sys/rootcontext.h"

# 1 "/usr/transputer/parix1.2/include/sys/sem.h"








 


# 62 "/usr/transputer/parix1.2/include/sys/sem.h"

 
# 20 "/usr/transputer/parix1.2/include/sys/rootcontext.h"

# 1 "/usr/transputer/parix1.2/include/sys/thread.h"


















 


# 100 "/usr/transputer/parix1.2/include/sys/thread.h"

 
# 21 "/usr/transputer/parix1.2/include/sys/rootcontext.h"


 



 
typedef struct {
    int             nContext;        
    int             LastContext;     
    List_t          ContextRoot;     
    int             nCodeCB;         
                                     
    int             nDummy;          
    CodeCB_t       *CacheTable [ 1024 ];
    int             Neighbour [ 4 ];
} RootContext_t;



 
# 45 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/comm.h"










 




 



 






 



extern int      Send (int TopId, int LogLinkId, void *Data, int Size);
extern int      Recv (int TopId, int LogLinkId, void *Data, int Size);

extern int      AInit (int TopId, int Threads, int Size);
extern int	AExit (int Top_Id);
extern int      ASend
                (int TopId, int LogLinkId, void *Data, int Size, int *Result);
extern int      ARecv
                (int TopId, int LogLinkId, void *Data, int size, int *Result);
extern int      ASync (int TopId, int LogLinkId);
extern int      AInfo (int TopId, int LogLinkId);

extern int      SendNode (int ProcId, int ReqId, void * Buffer, int Size);
extern int      RecvNode (int ProcId, int ReqId, void * Buffer, int Size);


# 62 "/usr/transputer/parix1.2/include/sys/comm.h"



 
# 46 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/monitor.h"








 





# 1 "/usr/transputer/parix1.2/include/sys/thread.h"


















 


# 100 "/usr/transputer/parix1.2/include/sys/thread.h"

 
# 15 "/usr/transputer/parix1.2/include/sys/monitor.h"

typedef (*FPNTR)();

typedef struct  _hook_struct
{
	FPNTR   hook_func;
	char            *in_par;
	char            *out_par;
	struct _hook_struct *next;
} HOOK_STRUCT;

typedef struct {
HOOK_STRUCT **hook_array;
Thread_t    **frame_id;
}		RootMonitor_t;


# 47 "/usr/transputer/parix1.2/include/sys/root.h"

# 1 "/usr/transputer/parix1.2/include/sys/profile.h"








 




 


# 1 "/usr/transputer/parix1.2/include/sys/types.h"

# 17 "/usr/transputer/parix1.2/include/sys/profile.h"

# 1 "/usr/transputer/parix1.2/include/sys/list.h"








 


# 81 "/usr/transputer/parix1.2/include/sys/list.h"

 
# 18 "/usr/transputer/parix1.2/include/sys/profile.h"

# 1 "/usr/transputer/parix1.2/include/sys/sem.h"








 


# 62 "/usr/transputer/parix1.2/include/sys/sem.h"

 
# 19 "/usr/transputer/parix1.2/include/sys/profile.h"

 



 



 

typedef struct {
    Node_t	node;			 
    ushort	*buf;			 
    int		bufcnt;			 
    uint	offset;			 
    uint	scale;			 
} ProfNode_t;

 
typedef struct {
    Semaphore_t	Lock;			 
    Semaphore_t	Wait;			 
    					 
    int		Count;			 
    List_t	List;			 
}               RootProfile_t;



 
# 48 "/usr/transputer/parix1.2/include/sys/root.h"

 

typedef struct {

    RootProc_t     *ProcRoot;		 
    RootHosts_t    *HostRoot;		 
    RootMemory_t   *MemRoot;		 
    RootLink_t     *LinkRoot;		 
    RootTops_t     *SysTopsRoot;	 
    RootTops_t     *UserTopsRoot;	 
    RootContext_t  *ContextRoot;	 
    RootMailBox_t  *MailBoxRoot;	 
    RootLogger_t   *LoggerRoot;		 
    RootDebug_t    *DebugRoot;		 
    RootMonitor_t  *MonitorRoot;	 
    RootProfile_t  *ProfileRoot;	 
    int            *DummyRoot;

}               RootData_t;






 
# 76 "/usr/transputer/parix1.2/include/sys/root.h"


 
# 6 "./channel.h"














 



 

# 29 "./channel.h"



# 36 "./channel.h"

# 40 "./channel.h"






# 414 "./packets.h"















 


# 520 "./packets.h"
 










# 532 "./packets.h"



# 536 "./packets.h"
 
 


 

# 552 "./packets.h"
 









# 19 "./mpid.h"



 




# 1 "./mpid_bind.h"


 







# 13 "./mpid_bind.h"

extern void MPID_PARIX_Abort  ( ) ;
extern void MPID_PARIX_Myrank  ( int * ) , 
            MPID_PARIX_Mysize  ( int * ) , 
            MPID_PARIX_End  (void) ;
extern void MPID_PARIX_Node_name  (char *, int ) ;
extern void MPID_PARIX_Version_name  (char *) ;

extern void *MPID_PARIX_Init  ( int *, char *** ) ;

extern int MPID_PARIX_post_send  ( MPIR_SHANDLE * ) , 
           MPID_PARIX_post_send_sync  ( MPIR_SHANDLE *) ,
           MPID_PARIX_complete_send  ( MPIR_SHANDLE *) ,
           MPID_PARIX_Blocking_send  ( MPIR_SHANDLE *) ,
           MPID_PARIX_post_recv  ( MPIR_RHANDLE * ) ,
           MPID_PARIX_blocking_recv  ( MPIR_RHANDLE *) , 
           MPID_PARIX_complete_recv  ( MPIR_RHANDLE *) ;
extern void MPID_PARIX_check_device  ( int ) , 
   MPID_PARIX_Probe  ( int, int, int, MPI_Status * ) ;
extern int MPID_PARIX_Iprobe  ( int, int, int, int *, MPI_Status * ) ;
extern int MPID_PARIX_Cancel  (MPIR_COMMON *) ; 
extern int MPID_PARIX_check_incoming  (MPID_BLOCKING_TYPE) ;

extern void MPID_SetSpaceDebugFlag  ( int ) ;
extern void MPID_SetDebugFile  ( char * ) ;


extern double MPID_PARIX_Wtime  (void) ;

extern double MPID_PARIX_Wtick  (void) ;




extern MPID_Aint MPID_PARIX_Get_Sync_Id 
     ( MPIR_SHANDLE *, MPID_SHANDLE * ) ;
extern int MPID_PARIX_Lookup_SyncAck 
     ( MPID_Aint, MPIR_SHANDLE **,MPID_SHANDLE **) ;
extern int MPID_SyncAck  ( MPID_Aint, int ) ;
extern void MPID_SyncReturnAck  ( MPID_Aint, int ) ;
extern void MPID_Sync_discard  ( MPIR_SHANDLE * ) ;

extern void MPID_PARIX_Pkt_pack  ( MPID_PKT_T *, int, int ) ;
extern void MPID_PARIX_Pkt_unpack  ( MPID_PKT_T *, int, int ) ;











 
extern int MPID_PARIX_Process_unexpected 
     ( MPIR_RHANDLE *, MPIR_RHANDLE *) ;
extern int MPID_PARIX_Copy_body 
     ( MPIR_RHANDLE *, MPID_PKT_T *, int) ;
extern int MPID_PARIX_Copy_body_unex
     ( MPIR_RHANDLE *, MPID_PKT_T *, int) ;
extern int MPID_PARIX_Ack_Request 
     ( MPIR_RHANDLE *, int, MPID_Aint, int ) ;
extern int MPID_PARIX_Complete_Rndv  ( MPID_RHANDLE * ) ;
extern int MPID_PARIX_Do_Request  ( int, int, MPID_Aint ) ;
extern void MPID_PARIX_Init_recv_code  (void) ;
extern void MPID_PARIX_Init_send_code   (void) ;
extern void MPID_PrintMsgDebug   (void) ;
extern void MPID_SetSyncDebugFlag   ( void *, int ) ;

 
extern void * MPID_SetupGetAddress  ( void *, int *, int ) ;
extern void   MPID_FreeGetAddress  ( void * ) ;

extern int MPID_PARIX_Do_get  ( MPIR_RHANDLE *, int, MPID_PKT_GET_T * ) ;

extern void MPID_PARIX_Get_print_pkt  (FILE *, MPID_PKT_T *) ;
extern void MPID_PARIX_Print_pkt_data  (char *, char *, int ) ;









# 27 "./mpid.h"








# 13 "parixevent.c"

# 1 "./mpiddebug.h"

 
 
 
extern int MPID_DebugFlag;

                        




# 18 "./mpiddebug.h"


# 30 "./mpiddebug.h"


# 40 "./mpiddebug.h"


# 54 "./mpiddebug.h"


# 60 "./mpiddebug.h"
	    

# 72 "./mpiddebug.h"


# 86 "./mpiddebug.h"


# 96 "./mpiddebug.h"


# 103 "./mpiddebug.h"


# 108 "./mpiddebug.h"


# 121 "./mpiddebug.h"


# 135 "./mpiddebug.h"


# 14 "parixevent.c"




 
void MPID_PARIX_check_device( blocking )
int blocking;
{
 {if (MPID_DebugFlag) { fprintf( MPID_DEBUG_FILE, "[%d]%s (%s:%d)\n",   ((RootData_t *) 0x80002000 ) ->ProcRoot->MyProcID , "Entering check device" ,  "parixevent.c" ,  22  ); fflush( MPID_DEBUG_FILE );}} 
if (blocking)
    (void) MPID_PARIX_check_incoming( MPID_BLOCKING );
else 
    while (MPID_PARIX_check_incoming( MPID_NOTBLOCKING ) != -1);
 {if (MPID_DebugFlag) { fprintf( MPID_DEBUG_FILE, "[%d]%s (%s:%d)\n",   ((RootData_t *) 0x80002000 ) ->ProcRoot->MyProcID , "Exiting check device" ,  "parixevent.c" ,  27  ); fflush( MPID_DEBUG_FILE );}} 
}








 
int MPID_PARIX_Cancel( r )
MPIR_COMMON *r;
{
MPIR_SHANDLE *sh;

MPID_SHANDLE *sdh;

	

 
if ( (( r  )->completer == 0) ) return  0  ;















 
switch (r->handle_type) {
    case MPIR_SEND:
        sh = (MPIR_SHANDLE*)r;
        if ( ((sh )->mode & (int)MPIR_MODE_SYNCHRONOUS) ) {
             
	    MPID_Sync_discard( sh );
            }

        
 
        sdh = &sh->dev_shandle;
        if (sdh->is_non_blocking && sdh->sid) {
	    MPID_CancelSendChannel( sdh->sid );
            sdh->sid = 0;
            }

         
    break;
    case MPIR_RECV:
         
    break;
    }
return  0  ;
}
