      program test_test
      implicit none
      include 'mpif.h'
c
      integer sid(32),rid(32),ierr,iam
      integer rbuf(1000),isbuf(1000),sbuf(1000)
      integer status(MPI_STATUS_SIZE),i,size
      logical flag
c
      call MPI_INIT(ierr)
      call MPI_COMM_SIZE(MPI_COMM_WORLD,size,ierr)
      call MPI_COMM_RANK(MPI_COMM_WORLD,iam,ierr)
      if (size.LT.4 .AND. iam.EQ.0) then
          Print *,' This program requires at least 4 processes'
      endif

	 call mpid_setdebugflag(0,1) 
	 call mpid_parix_setdebugflag(0,1) 
         call mpid_setdebugfile("t2_%d.pro");
c


      do 10 i=0,size-1
        if (i.ne.iam) then
        call MPI_ISEND(isbuf,1000,MPI_INTEGER,i,0,
     &   MPI_COMM_WORLD,sid(i),ierr)
        endif
10    end do

      Print *,iam,' ISend done'

      do 20 i=0,size-1
        if (i.ne.iam) then
        call MPI_RECV(rbuf,1000,MPI_INTEGER,i,0,
     &   MPI_COMM_WORLD,status,ierr)
        Print *,iam,' recv to',i,' done'
        endif
20    end do

      Print *,iam,' all Recv done'



      do 30 i=0,size-1
        if (i.ne.iam) then
          call MPI_WAIT(sid(i),status,ierr)
c
        Print *,iam,' Test for ',i,' completed with ', status,flag
        endif
 30   end do

c
      call MPI_FINALIZE(ierr)
      end
